unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, GDIPAPI, GDIPOBJ, GDIPUTIL, GPWinControl, GDIPColorDisplay, ColorSelectorFrame,
  GDIPFontCombo, TntStdCtrls, TntExDropDownEdit, GDIPDropDownColorSelector,
  XPMan, VirtualTrees, ExtCtrls, TntExtCtrls, TntExDropDownControl,
  TntExDropDownVirtualDrawTree, GDIPImageBrowser, TntExWinControl, Menus,
  TntMenus, TntExDropDownVirtualStringTree, ComCtrls, GDIPExtensions;

type
  TForm1 = class(TForm)
    XPManifest1: TXPManifest;
    TntPopupMenu1: TTntPopupMenu;
    None1: TTntMenuItem;
    Checked1: TTntMenuItem;
    Black1: TTntMenuItem;
    Red1: TTntMenuItem;
    Green1: TTntMenuItem;
    Blue1: TTntMenuItem;
    White1: TTntMenuItem;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    GDIPCanvas1: TGDIPCanvas;
    Label1: TLabel;
    Label2: TLabel;
    GDIPFontCombo1: TGDIPFontCombo;
    Label3: TLabel;
    GDIPColorDisplay1: TGDIPColorDisplay;
    Label4: TLabel;
    GDIPColorSelector1: TGDIPColorSelector;
    TabSheet2: TTabSheet;
    GDIPImageBrowser1: TGDIPImageBrowser;
    ImagePreview: TGDIPCanvas;
    exampleCanvas: TGDIPCanvas;
    Label5: TLabel;
    btnSplitPng: TButton;
    SplitBmpCanvas: TGDIPCanvas;
    SplitMaskCanvas: TGDIPCanvas;
    JoinCanvas: TGDIPCanvas;
    Button1: TButton;
    clean: TButton;
    pageFade: TTabSheet;
    GDIPCanvas2: TGDIPCanvas;
    Label6: TLabel;
    faderesultcanvas: TGDIPCanvas;
    btnFade: TButton;
    Label7: TLabel;
    cbFadeLeft: TTntCheckBox;
    cbFadeRight: TTntCheckBox;
    cbFadeTop: TTntCheckBox;
    cbFadeBottom: TTntCheckBox;
    procedure GDIPColorSelector1Change(Sender: TObject;
      AlphaColor: Cardinal);
    procedure GDIPCanvas1Paint(Canvas: TGPGraphics);
    procedure GDIPFontCombo1Change(Sender: TObject);
    procedure None1Click(Sender: TObject);
    procedure GDIPImageBrowser1Change(Sender: TObject);
    procedure ImagePreviewPaint(Canvas: TGPGraphics);
    procedure TabSheet2Show(Sender: TObject);
    procedure exampleCanvasPaint(Canvas: TGPGraphics);
    procedure JoinCanvasPaint(Canvas: TGPGraphics);
    procedure SplitBmpCanvasPaint(Canvas: TGPGraphics);
    procedure SplitMaskCanvasPaint(Canvas: TGPGraphics);
    procedure btnSplitPngClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure cleanClick(Sender: TObject);
    procedure btnFadeClick(Sender: TObject);
    procedure faderesultcanvasPaint(Canvas: TGPGraphics);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.GDIPColorSelector1Change(Sender: TObject;
  AlphaColor: Cardinal);
begin
  GDIPColorDisplay1.AlphaColor := GDIPColorSelector1.AlphaColor;
  GDIPCanvas1.invalidate;
end;

procedure TForm1.GDIPCanvas1Paint(Canvas: TGPGraphics);
var
  brush : TGPBrush;
  afont : TGPFont;
  s : widestring;
  p : TGPPointF;
  sf : TGPStringFormat;
begin
  afont := TGPFont.Create(GDIPFontCombo1.FontName,38);
  brush :=  TGPLinearGradientBrush.Create(MakePoint(0,0),MakePoint(40,40),GDIPColorSelector1.AlphaColor,MakeColor(255,0,0,255));
  s := 'GDI+ Controls';
  p := makepoint(0.0,0.0);
  sf := TGPStringFormat.create;
  canvas.DrawString(s,length(s),afont,p,sf,brush);
  sf.free;
  brush.free;
  afont.free;
end;

procedure TForm1.GDIPFontCombo1Change(Sender: TObject);
begin
  GDIPCanvas1.invalidate;
end;

procedure TForm1.None1Click(Sender: TObject);
begin
  if sender is TMenuitem then
  begin
    GDIPImageBrowser1.ImageBackground := TImageBackground(TMenuitem(sender).Tag);
  end;
end;

procedure TForm1.GDIPImageBrowser1Change(Sender: TObject);
begin
  ImagePreview.Invalidate;
end;

procedure TForm1.ImagePreviewPaint(Canvas: TGPGraphics);
var
  img : TGPImage;
  srect, drect, orect : TGPrect;
  Zoom : double;
begin
  if fileexists(GDIPImageBrowser1.Filename) then
  begin
    img := TGPImage.create(GDIPImageBrowser1.Filename);
    srect := makerect(0,0,integer(img.GetWidth), integer(img.GetHeight));
    drect := makerect(0,0,ImagePreview.Width, ImagePreview.Height);
    orect := MaintainAspect(srect,drect,zoom,[roSourceIsMax,roCenterVertical,roCenterHorizontal]);
    canvas.DrawImage(img,orect);
    img.free;
  end;
end;

procedure TForm1.TabSheet2Show(Sender: TObject);
begin
  GDIPImageBrowser1.Refresh;
end;

procedure TForm1.exampleCanvasPaint(Canvas: TGPGraphics);
var
  img : TGPbitmap;
begin
  if fileexists(extractfilepath(Application.ExeName) + 'example.png') then
  begin
    img := TGPBitmap.create(extractfilepath(Application.ExeName) + 'example.png');
    if assigned(img) then canvas.DrawImage(img,makerect(0,0,128,128));
    img.free;
  end;
end;

procedure TForm1.JoinCanvasPaint(Canvas: TGPGraphics);
var
  img : TGPbitmap;
begin
  if fileexists(extractfilepath(Application.ExeName) + 'joined.png') then
  begin
    img := TGPBitmap.create(extractfilepath(Application.ExeName) + 'joined.png');
    if assigned(img) then canvas.DrawImage(img,makerect(0,0,128,128));
    img.free;
  end;
end;

procedure TForm1.SplitBmpCanvasPaint(Canvas: TGPGraphics);
var
  img : TGPbitmap;
begin
  if fileexists(extractfilepath(Application.ExeName) + 'split-bmp.bmp') then
  begin
    img := TGPBitmap.create(extractfilepath(Application.ExeName) + 'split-bmp.bmp');
    if assigned(img) then canvas.DrawImage(img,makerect(0,0,128,128));
    img.free;
  end;
end;

procedure TForm1.SplitMaskCanvasPaint(Canvas: TGPGraphics);
var
  img : TGPbitmap;
begin
  if fileexists(extractfilepath(Application.ExeName) + 'split-mask.bmp') then
  begin
    img := TGPBitmap.create(extractfilepath(Application.ExeName) + 'split-mask.bmp');
    if assigned(img) then canvas.DrawImage(img,makerect(0,0,128,128));
    img.free;
  end;
end;

procedure TForm1.btnSplitPngClick(Sender: TObject);
var
  img : TGPbitmap;
  mask, bitmap : TGPbitmap;
  enc : TGUID;
begin
  if fileexists(extractfilepath(Application.ExeName) + 'example.png') then
  begin
    img := TGPBitmap.create(extractfilepath(Application.ExeName) + 'example.png');
    if assigned(img) then
    begin
      if SplitAlpha(img,bitmap,mask) then
      begin
        if assigned(bitmap) then
        begin
          GetEncoderClsid('image/bmp', enc);
          bitmap.Save('split-bmp.bmp',enc);
        end;
        if assigned(mask) then
        begin
          GetEncoderClsid('image/bmp', enc);
          mask.Save('split-mask.bmp',enc);
        end;
      end;
      FreeAndNil(bitmap);
      FreeAndNil(mask);
    end;
    img.free;
    SplitBmpCanvas.Invalidate;
    SplitMaskCanvas.Invalidate;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  img : TGPbitmap;
  mask, bitmap : TGPbitmap;
  enc : TGUID;
begin
  if fileexists(extractfilepath(Application.ExeName) + 'split-bmp.bmp') then
  begin
    bitmap := TGPBitmap.create(extractfilepath(Application.ExeName) + 'split-bmp.bmp');
    if fileexists(extractfilepath(Application.ExeName) + 'split-mask.bmp') then
    begin
      mask := TGPBitmap.create(extractfilepath(Application.ExeName) + 'split-mask.bmp');

      if CombineImageMask(bitmap,mask, img) then
      begin
        if assigned(img) then
        begin
          GetEncoderClsid('image/png', enc);
          img.Save('joined.png',enc);
          FreeAndNil(img);
          JoinCanvas.Invalidate;
        end;
      end;
      FreeAndNil(mask);
    end;
    FreeAndNil(bitmap);
  end;
end;

procedure TForm1.cleanClick(Sender: TObject);
var
  fname : string;
begin
  fname := extractfilepath(Application.ExeName) + 'split-bmp.bmp';
  if fileexists(fname) then DeleteFile(fname);
  fname := extractfilepath(Application.ExeName) + 'split-mask.bmp';
  if fileexists(fname) then DeleteFile(fname);
  fname := extractfilepath(Application.ExeName) + 'joined.png';
  if fileexists(fname) then DeleteFile(fname);
  JoinCanvas.Invalidate;
  SplitBmpCanvas.Invalidate;
  SplitMaskCanvas.Invalidate;
end;

procedure TForm1.btnFadeClick(Sender: TObject);
var
  img : TGPbitmap;
  mask, bitmap : TGPbitmap;
  enc : TGUID;
begin
  if fileexists(extractfilepath(Application.ExeName) + 'example.png') then
  begin
    bitmap := TGPBitmap.create(extractfilepath(Application.ExeName) + 'split-bmp.bmp');
    if fileexists(extractfilepath(Application.ExeName) + 'example.png') then
    begin
      if cbFadeTop.checked then FadeOut(bitmap,makerect(0,0,integer(bitmap.getwidth),20),fdUp,ftLinear);
      if cbFadeBottom.checked then FadeOut(bitmap,makerect(0,integer(bitmap.getheight-20),integer(bitmap.getwidth),20),fdDown,ftLinear);
      if cbFadeLeft.checked then FadeOut(bitmap,makerect(0,0,20,integer(bitmap.getheight)),fdLeft,ftLinear);
      if cbFadeRight.checked then FadeOut(bitmap,makerect(integer(bitmap.getWidth-20),0,20,integer(bitmap.getheight)),fdRight,ftLinear);

      begin
        GetEncoderClsid('image/png', enc);
        bitmap.Save('faded.png',enc);
        FreeAndNil(bitmap);
        faderesultcanvas.Invalidate;

      end;
    end;
    FreeAndNil(bitmap);
  end;
end;

procedure TForm1.faderesultcanvasPaint(Canvas: TGPGraphics);
var
  img : TGPbitmap;
begin
  if fileexists(extractfilepath(Application.ExeName) + 'faded.png') then
  begin
    img := TGPBitmap.create(extractfilepath(Application.ExeName) + 'faded.png');
    if assigned(img) then canvas.DrawImage(img,makerect(0,0,128,128));
    img.free;
  end;
end;

end.

